//#include <AIV/Matrices.mqh>

#property indicator_separate_window
#property indicator_buffers 2
#property indicator_plots 2

#property indicator_label1 "A"
#property indicator_type1 DRAW_LINE
#property indicator_color1 clrRed
#property indicator_width1 1

#property indicator_label2 "B"
#property indicator_type2 DRAW_LINE
#property indicator_color2 clrBlue
#property indicator_width2 1

input double InpSize = 0.00500;

struct SCandles
{
  double O[];
  double H[];
  double L[];
  double C[];
  double I[];
  double A[];
  double B[];
};

ulong iTime;
ulong iStart;
double iPrice;

struct SSets
{
  string name;
  MqlTick ticks[];
  MqlRates rates[];
};

//CSets * iSets;
//CHelpers * iHelpers;

SSets iSeries;
SCandles iCandles;

void OnDeinit(const int reason)
{
  //delete(iSets);
  //delete(iHelpers);
}

void OnInit()
{
  SetIndexBuffer(0, iCandles.A, INDICATOR_DATA); 
  SetIndexBuffer(1, iCandles.B, INDICATOR_DATA); 

  //SetIndexBuffer(0, iCandles.O, INDICATOR_DATA); 
  //SetIndexBuffer(1, iCandles.H, INDICATOR_DATA); 
  //SetIndexBuffer(2, iCandles.L, INDICATOR_DATA); 
  //SetIndexBuffer(3, iCandles.C, INDICATOR_DATA);
  //SetIndexBuffer(4, iCandles.I, INDICATOR_COLOR_INDEX); 

  PlotIndexSetDouble(0, PLOT_EMPTY_VALUE, 0); 

  ArraySetAsSeries(iCandles.A, true);
  ArraySetAsSeries(iCandles.B, true);

  //ArraySetAsSeries(iCandles.O, true);
  //ArraySetAsSeries(iCandles.H, true);
  //ArraySetAsSeries(iCandles.L, true);
  //ArraySetAsSeries(iCandles.C, true);
  //ArraySetAsSeries(iCandles.I, true);

  IndicatorSetString(INDICATOR_SHORTNAME, "Ticks");
  IndicatorSetInteger(INDICATOR_DIGITS, 5);

  //iSets = new CSets();
  //iHelpers = new CHelpers();

  iTime = 0;
  iStart = 0;
  iPrice = 0;
  iSeries.name = Symbol();

  int mode = MQLInfoInteger(MQL_TESTER);

  if (mode == 0)
  {
    EventSetMillisecondTimer(1000);
  }
}

void OnTimer()
{
}

int OnCalculate(const int bars, const int counted, const int start, const double &price[])
{
  ulong date = TimeCurrent() * 1000;  

  if (iStart == 0)
  {
    ulong next = History(iSeries, date - 1 * PeriodSeconds(PERIOD_D1) * 1000, date);

    if (next)
    {
      iStart = 1;
      iTime = next;
    }

    return bars;
  }
  
  if (bars != counted)
  {
    //MoveChart(1);
  }
/*
  ulong next = Live(iSeries, iTime, date);

  if (next)
  {
    iTime = next;
  }
*/
  return bars;
}

void MoveChart(int direction)
{
  int count = ArraySize(iCandles.I);

  if (direction > 0) 
  {
    for (int k = 0; k < count - 1; k++)
    {
      iCandles.O[k] = iCandles.O[k + 1];
      iCandles.H[k] = iCandles.H[k + 1];
      iCandles.L[k] = iCandles.L[k + 1];
      iCandles.C[k] = iCandles.C[k + 1];
      iCandles.I[k] = iCandles.I[k + 1];
    }
  }
  else
  {
    for (int k = count - 1; k > 0; k--)
    {
      iCandles.O[k] = iCandles.O[k - 1];
      iCandles.H[k] = iCandles.H[k - 1];
      iCandles.L[k] = iCandles.L[k - 1];
      iCandles.C[k] = iCandles.C[k - 1];
      iCandles.I[k] = iCandles.I[k - 1];
    }
  }
}

ulong Live(SSets &series, ulong start, ulong end)
{
  int count = getTicks(series, start, end);
  
  if (count > 0) 
  {
    for (int indexTick = count - 1; indexTick >= 0; indexTick--)
    {
      double distance = NormalizeDouble(series.ticks[indexTick].last - iPrice, 5);

      if (MathAbs(distance) > InpSize)
      {
        double direction = 1;
        double distances = MathCeil(MathAbs(distance) / InpSize);

        if (distance < 0)
        {
          direction = -1;
        }

        for (int n = 0; n < distances; n++)
        {
          MoveChart(-1);
          iCandles.C[0] = series.ticks[indexTick].last;
          iCandles.O[0] = iCandles.C[0] - InpSize * direction;
          iCandles.H[0] = MathMax(iCandles.O[0], iCandles.C[0]);
          iCandles.L[0] = MathMin(iCandles.O[0], iCandles.C[0]);
          iCandles.I[0] = iCandles.C[0] > iCandles.O[0] ? 1 : 0;
          iPrice = iCandles.C[0];
        }
        
        iPrice = series.ticks[indexTick].last;
      }
    }

    return end;
  }
  
  return 0;
}

ulong History(SSets &series, ulong start, ulong end)
{
  ZeroMemory(iCandles);

  uint count = getTicks(series, start, end, true);
  
  if (count > 0) 
  {
    uint indexBar = 0;
    uint indexTick = 0;
    uint maxBars = TerminalInfoInteger(TERMINAL_MAXBARS);

    iPrice = series.ticks[indexTick].last;

    for (indexTick = 0; indexTick < count - 1 && indexTick < maxBars - 1; indexTick++)
    {
//Print(indexTick, " ", series.ticks[indexTick].ask, " ", series.ticks[indexTick].time);
      double distance = NormalizeDouble(iPrice - series.ticks[indexTick].last, 5);
iCandles.A[indexTick] = series.ticks[indexTick].ask;
iCandles.B[indexTick] = series.ticks[indexTick].bid;
      if (MathAbs(distance) >= InpSize)
      {
        double direction = 1;
        double distances = MathCeil(MathAbs(distance) / InpSize);

        if (distance < 0)
        {
          direction = -1;
        }

        for (int n = 0; n < distances && indexBar < maxBars; n++)
        {
/*
          iCandles.C[indexBar] = iPrice;
          iCandles.O[indexBar] = iCandles.C[indexBar] - InpSize * direction;
          iCandles.H[indexBar] = MathMax(iCandles.O[indexBar], iCandles.C[indexBar]);
          iCandles.L[indexBar] = MathMin(iCandles.O[indexBar], iCandles.C[indexBar]);
          iCandles.I[indexBar] = iCandles.C[indexBar] > iCandles.O[indexBar] ? 1 : 0;
          iPrice = iCandles.O[indexBar];
*/
          indexBar++;
        }
        
        iPrice = series.ticks[indexTick].last;
      }
    }

    for (uint k = indexBar + 1; k < maxBars; k++)
    {
//      iCandles.O[k] = iCandles.H[k] = iCandles.L[k] = iCandles.C[k] = iPrice;
//      iCandles.I[k] = 0;
    }

    return end;
  }
  
  return 0;
}

    int getTicks(
      SSets& series, 
      const ulong start = 0, 
      const ulong end = 0,
      const bool any = false)
    {
      int items = CopyTicksRange(series.name, series.ticks, COPY_TICKS_ALL, start, end);

      if (any && items < 1)
      {
        items = CopyTicks(series.name, series.ticks, COPY_TICKS_ALL, 0, 100000);
      }

      ArraySetAsSeries(series.ticks, true);

      if (items < 1)
      {
        Print(
          "Synchronization : " + series.name + ", " + 
          "Start : " + TimeToString(start / 1000) + ", " + 
          "End : " + TimeToString(end / 1000));

        return 0;
      }

      return items;
    }